/*
    TCFbEColumnColumnCachedTable.cpp    November 29, 2004.

    Copyright (C) 2003-2004 CFbE Research Group,
    Software Engineering Laboratory,
    Graduate School of Information Science,
    Nara Institute of Science and Technology,
    All rights reserved.

    This program is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2, (at your option) or
    any later version.

    This program is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GNU Emacs; see the file COPYING.  If not, write to the
    Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/
//---------------------------------------------------------------------------
#pragma hdrstop

#include "TCFbEColumnColumnCachedTable.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
// コンストラクタ（空キャッシュを作成
__fastcall TCFbEColumnColumnCachedTable::TCFbEColumnColumnCachedTable(void)
    : TCFbECachedTable()
{
}

//---------------------------------------------------------------------------
// 指定された行列を備えた空テーブルを作成
__fastcall TCFbEColumnColumnCachedTable::TCFbEColumnColumnCachedTable(TStringList* RowLabelList, TStringList* ColumnLabelList)
    : TCFbECachedTable(ColumnLabelList, ColumnLabelList)
{
}

//---------------------------------------------------------------------------
// デストラクタ
__fastcall TCFbEColumnColumnCachedTable::~TCFbEColumnColumnCachedTable()
{
}

//---------------------------------------------------------------------------
// 以下，protected method
//---------------------------------------------------------------------------
// 親キャッシュのセルが更新された
void __fastcall TCFbEColumnColumnCachedTable::ParentCellIsUpdated(int RowIndex, int ColumnIndex)
{
    if (!this->FIsLinkedToParent) {
        return;
    }

    for (int i = 0; i < this->GetNumberOfRows(); i++) {
        this->UnableElementByIndex(i, ColumnIndex);
        this->UnableElementByIndex(ColumnIndex, i);
    }
}

//---------------------------------------------------------------------------
// 親キャッシュの行が追加された
int __fastcall  TCFbEColumnColumnCachedTable::ParentAddRow(const char* RowLabel)
{
    return -1;
}

//---------------------------------------------------------------------------
// 親キャッシュの列が追加された
int __fastcall  TCFbEColumnColumnCachedTable::ParentAddColumn(const char* ColumnLabel)
{
    this->AddRow(ColumnLabel);
    return this->AddColumn(ColumnLabel);
}

//---------------------------------------------------------------------------
// 親キャッシュの行が削除された
void __fastcall TCFbEColumnColumnCachedTable::ParentDeleteRowByIndex(int TargetRowIndex)
{
    return;
}

//---------------------------------------------------------------------------
// 親キャッシュの列が削除された
void __fastcall TCFbEColumnColumnCachedTable::ParentDeleteColumnByIndex(int TargetColumnIndex)
{
    this->DeleteRowByIndex(TargetColumnIndex);
    this->DeleteColumnByIndex(TargetColumnIndex);
}

//---------------------------------------------------------------------------
// 自分自身のクローンを作成する
TCFbECachedTable* __fastcall TCFbEColumnColumnCachedTable::CreateClone(void)
{
    TCFbEColumnColumnCachedTable* Clone = new TCFbEColumnColumnCachedTable();
    Clone->Assign(this);
    return Clone;       
}

//---------------------------------------------------------------------------
// 自分自身の行と列が入れ替わったクローンを作成する
TCFbECachedTable* __fastcall TCFbEColumnColumnCachedTable::CreateRotatedClone(void)
{
    TCFbEColumnColumnCachedTable* Clone = new TCFbEColumnColumnCachedTable();
    Clone->RotatedAssign(this);
    return Clone;
}

//---------------------------------------------------------------------------

